#!/usr/bin/env python
# obs.py

"""
Author : peters 

Revision History:
File created on 28 Jul 2010.

"""
import os
import sys
import logging
import datetime

identifier = 'Observation baseclass'
version    = '0.0'

################### Begin Class Observation ###################

class Observation(object):
    """ an object that holds data + methods and attributes needed to manipulate observations for a DA cycle """

    def __init__(self):
        self.Identifier = self.getid()
        self.Version    = self.getversion()
        self.Data       = ObservationList([])  # Initialize with an empty list of obs

        msg                 = 'Observation object initialized: %s'%self.Identifier ; logging.info(msg)

    def getid(self):
        return identifier

    def getversion(self):
        return identifier

    def __str__(self):
        """ Prints a list of Observation objects"""
        return "This is a %s object, version %s"%(self.Identifier,self.Version)

    def Initialize(self):
        """ Perform all steps needed to start working with observational data, this can include moving data, concatenating files,
            selecting datasets, etc.
        """

    def Validate(self):
        """ Make sure that data needed for the ObservationOperator (such as observation input lists, or parameter files)
            are present.
        """

    def AddObs(self):
        """ Add the observation data to the Observation object. This is in a form of a list that goes under the name Data. The
            list has as only requirement that it can return the observed+simulated values through a method "getvalues"
        """

    def AddSimulations(self):
        """ Add the simulation data to the Observation object. 
        """

    def AddModelDataMismatch(self, DaCycle):
        """ 
            Get the model-data mismatch values for this cycle.

        """

    def WriteSampleInfo(self, DaCycle):
        """ 
            Write the information needed by the observation operator to a file. Return the filename that was written for later use
        """



################### End Class Observations ###################

################### Begin Class ObservationList ###################

class ObservationList(list):
    """ This is a special type of list that holds observed sample objects. It has methods to extract data from such a list easily """
    from numpy import array, ndarray

    def getvalues(self,name,constructor=array):
            from numpy import ndarray
            result = constructor([getattr(o,name) for o in self])
            if isinstance(result,ndarray): 
                return result.squeeze()
            else:
                return result

################### End Class MixingRatioList ###################

